public class LinkedList<A> {

	private Node<A> start; 														// Attribut start mit Node mit Genertic als Datentyp

	private int size; 															// Attribut size

	public LinkedList() {													    // Konstruktor der Liste
		this.start = null; 														// Attribute von oben werden initilaisiert
		this.size = 0;
		this.size = this.size -1; 
	}

	public boolean isEmpty() {										// Klasse fragt ab ob die liste leer ist
		if (size == 0) {										// wenn l‰nge der liste 0 ist
				
			return true;										// gibt true zur¸ck weil es boolean ist
		} else {												// wenn oberes nicht erfÔøΩllt wird
				
		return false;											// gibt false zur¸ck wegen boolean
	}
}

	public void add(A wert) { 													// Methode f‰ngt hinten an die Liste etwas an
		this.size++; 															// grˆﬂe wird hochgez‰hlt da liste um ein grˆﬂer werden muss

		if (this.start == null) { 												// wenn start wert = 0 ist
			this.start = new Node<A>(wert);										 // start wird zu neuem Knoten mit wert wert
		} else { 																// wenn obere if bedingung nicht erf¸llt wird dann soll er volgendes ausgef¸hrt
			Node<A> current = this.start; 										// current bekommt den wert der start zugewissen wurde
			while (current.next != null) { 										// w‰hrend nachfolger des jetzigen Knotens ungleich null ist
				current = current.next; 										// wird current dem n‰chsten werd zugewissen

			}
			current.next = new Node<A>(wert); 									// dem jetzigen Knoten wird als 2ter eintrag ein neuer Knoten zugewissen
		}
	}

	public void addziwschen(A wert, int n) { 									// Methode um werte dazwischen einzuf¸gen
		if (n < size) { 														// wenn die l‰nge der Liste grˆﬂer ist als Index in dem man etwas einf¸gen will
			size++; 															// L‰nge wird eins Hochgez‰hlt
			if (n < 2) { 														// wenn index kleiner als 2 ist, also wenn er bei der ersten stelle ist
				Node<A> Neu = new Node<A>(wert); 								// neuer Knoten mit dem namen Nue wird angelegt und der wert "wert"
																				// wird ¸bergeben
				Neu.next = start;												// 2ter eintrag vom Knoten "Neu" wird als start festgelegt
				start = Neu; 													// start wird zum ersten eintrage von neu
			} else { 															// wenn obere if bedingung nicht erf¸llt wird
				Node<A> Neu = new Node<A>(wert);								// neuer Knoten namen neu wird erstellt und der wert "wert" wird dem
																				// zugewissen
				Node<A> current = this.start; 									// neuer Knoten "current" wird erstellet und der wert von "this.start"
																				// wird ¸bergeben

				int a = 0;														// neue variable wird erstellt

				while (a != n - 2) { 											// w‰hrend 0 ungleich dem index - 2 ist
					current = current.next;										// dann wird "current" gleich dem 2ten werd des Knotens gesetzt
					a++; 													    // a wird hochgez‰hlt um zum gew¸nschten Index zu gelangen
				}

				Neu.next = current.next; 										// 2ter werd von dem Knoten neu wird gleich dem 2ten werd von dem Knoten
																				// currentn gesetzt
				current.next = Neu; 											// 2ter werd wird Knoten Neu zeugewissen
			}
		} else {

			add(wert);															//wenn grˆﬂer ist soll der den wert hinten einf¸gen
		}
	}

	public A get(int n) {													// Methode um auf index gespeicherten wert zu bekommen

		Node<A> current = this.start;											// neue Node current wird mit dem wert start "bef¸llt"
 
		for (int i = 0; i < n ; i++) {										// solange der index grˆﬂer als i ist geht er das in der SChleife durch 
			current = current.next;												// solange wird der Knoten current gleich dem 2ten werd im Knoten gesetzt 
		}
			A I  =current.wert; 
	return I; 
	}

	public boolean contains(A wert) {											//gibt aus ob ein wert in der Liste ist 
		Node<A> current = this.start;											// Knoten current wird der wert start zugewissen
		while (current != null) {												// solange current ungleich null ist wird das in der Schleife ausgefÔøΩhrt

			if (current.wert == wert) {											// wenn der der Knoten current = der wert ist 
				System.out.println(wert + " " + "ist in der Liste");
				return true;													// dann gibt es den eintrag also muss er true zurÔøΩckgeben 
			}
			current = current.next;											 	// n‰chster wert wird zum aktuellen 										

		}
		System.out.println(wert + " " + "ist nicht in der Liste");
		return false;															// sonst ist er nicht drin 
	}

	public A remove(int n) {												    // Methode zum lˆschen eines Knotens 
		Node<A> current = this.start;											// neuer Knoten current wird erstellt
		if(n > size) {
			return null; 
		}
		if (n > 1) {															// wenn index grˆﬂer 1 ist 

			int i = 1;																//neue Variable 
			while (i != n -1) {												// solange i ungleich dem index - 1 ist 
				current = current.next;											// wird der jetzige wert dem 2ten zugewissen 
				i++;															// wird hochgez‰hlt um den richtigen index zu erreichen 
			}	
			current.next = current.next.next;									// 2ter wert wird dem ¸bergeordneten wert zugewissen 
			size--;																//grˆﬂe wird ein runtergez‰hlt um es zu lˆschen 
		} else {
			this.start = current.next;											// sonst ist start der 2te eintrag
		}
	  A I  = current.wert; 
	  return I; 
	}

	public int grˆﬂe() {														// Methode um grˆﬂe auszugeben 
		System.out.print("Die Grˆﬂe der Liste ist: ");							//ausgabe
		System.out.println(size + "\n");										//ausgabe 
		return size;															// gibt grˆﬂe zur¸ck
	}

	public Node<A> getStart() {													// getter Mehode f¸r Start 
		return this.start;
	}
	
	public int size() {															// getter Mehode f¸r grˆﬂe 
		return this.size;
	}

}